/* 
###########################################################
  Title:       Arduino Oscilloscope
  Purpose:     Use a Nokia 3310 GLCD screen with the arduino
  Created by:  Fileark. see Fileark.com for more info.
  Note:        Please reuse, repurpose, and redistribute this code.
  Note:        This code uses the Adafruit PDC8544 LCD library  
###########################################################
 */

#include "PCD8544.h"

// pin 3 - Serial clock out (SCLK)
// pin 4 - Serial data out (DIN)
// pin 5 - Data/Command select (D/C)
// pin 7 - LCD chip select (CS)
// pin 6 - LCD reset (RST)
PCD8544 nokia = PCD8544(3, 4, 5, 7, 6);

// a bitmap of a 16x16 fruit icon
static unsigned char __attribute__ ((progmem)) logo16_glcd_bmp[]={
0x06, 0x0D, 0x29, 0x22, 0x66, 0x24, 0x00, 0x01, 0x87, 0x00, 0x27, 0x6C, 0x20, 0x23, 0x06, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
#define LOGO16_GLCD_HEIGHT 16 
#define LOGO16_GLCD_WIDTH  16 

int channelAI = A0;      // select the input pin for the Oscilioscope
int scaleYAI = A1;       // select the input pin for the Y (horizontal) potentiometer
int scaleXAI = A2;       // select the input pin for the X (Vertical) potentiometer

int delayVariable = 0;   // define a variable for the Y scale / delay
int xVariable = 0;       // define a variable for the x scale 
int val1 = 0;
int val2 = 0;
int val3 = 0;
int val4 = 0;
int val5 = 0;
int val6 = 0;
int val7 = 0;
int val8 = 0;
int val9 = 0;
int val10 = 0;
int val11 = 0;
int val12 = 0;
int val13 = 0;
int val14 = 0;
int val15 = 0;
int val16 = 0;
int val17 = 0;
int val18 = 0;
int val19 = 0;
int val20 = 0;
int val21 = 0;
int val22 = 0;
int val23 = 0;
int val24 = 0;
int val25 = 0;
int val26 = 0;
int val27 = 0;
int val28 = 0;
int val29 = 0;
int val30 = 0;
int val31 = 0;
int val32 = 0;
int val33 = 0;
int val34 = 0;
int val35 = 0;
int val36 = 0;
int val37 = 0;
int val38 = 0;
int val39 = 0;
int val40 = 0;
int val41 = 0;
int val42 = 0;
int val43 = 0;
int val44 = 0;
int val45 = 0;
int val46 = 0;
int val47 = 0;
int val48 = 0;
int val49 = 0;
int val50 = 0;
int val51 = 0;
int val52 = 0;
int val53 = 0;
int val54 = 0;
int val55 = 0;
int val56 = 0;
int val57 = 0;
int val58 = 0;
int val59 = 0;
int val60 = 0;
int val61 = 0;
int val62 = 0;
int val63 = 0;
int val64 = 0;
int val65 = 0;
int val66 = 0;
int val67 = 0;
int val68 = 0;
int val69 = 0;
int val70 = 0;
int val71 = 0;
int val72 = 0;
int val73 = 0;
int val74 = 0;
int val75 = 0;
int val76 = 0;
int val77 = 0;
int val78 = 0;
int val79 = 0;
int val80 = 0;
int val81 = 0;
int val82 = 0;
int val83 = 0;
int val84 = 0;



void setup(void) 
{

  nokia.init();
  
  // turn all the pixels on (a handy test)
    nokia.command(PCD8544_DISPLAYCONTROL | PCD8544_DISPLAYALLON);
    delay(500);
  // back to normal
    nokia.command(PCD8544_DISPLAYCONTROL | PCD8544_DISPLAYNORMAL);
  
  // show splashscreen
    nokia.display();
    delay(500);
    nokia.clear();
}

void loop() 
{  
  delayVariable = analogRead(scaleYAI);
  delayVariable = (delayVariable/50);
  xVariable = analogRead(scaleXAI);
  xVariable = (xVariable/22); 
  
      val1 = analogRead(channelAI);       
      val1 = (val1/xVariable);          
      val2 = analogRead(channelAI);      
      val2 = (val2/xVariable); 
      val3 = analogRead(channelAI);       
      val3 = (val3/xVariable);          
      val4 = analogRead(channelAI);      
      val4 = (val4/xVariable);   
      val5 = analogRead(channelAI);       
      val5 = (val5/xVariable);          
      val6 = analogRead(channelAI);      
      val6 = (val6/xVariable); 
      val7 = analogRead(channelAI);       
      val7 = (val7/xVariable);          
      val8 = analogRead(channelAI);      
      val8 = (val8/xVariable); 
      val9 = analogRead(channelAI);       
      val9 = (val9/xVariable);          
      val10 = analogRead(channelAI);      
      val10 = (val10/xVariable);  
      val11 = analogRead(channelAI);       
      val11 = (val11/xVariable);          
      val12 = analogRead(channelAI);      
      val12 = (val12/xVariable); 
      val13 = analogRead(channelAI);       
      val13 = (val13/xVariable);          
      val14 = analogRead(channelAI);      
      val14 = (val14/xVariable);   
      val15 = analogRead(channelAI);       
      val15 = (val5/xVariable);          
      val16 = analogRead(channelAI);      
      val16 = (val16/xVariable); 
      val17 = analogRead(channelAI);       
      val17 = (val17/xVariable);          
      val18 = analogRead(channelAI);      
      val18 = (val18/xVariable); 
      val19 = analogRead(channelAI);       
      val19 = (val19/xVariable);          
      val20 = analogRead(channelAI);      
      val20 = (val20/xVariable);  
      val21 = analogRead(channelAI);       
      val21 = (val21/xVariable);          
      val22 = analogRead(channelAI);      
      val22 = (val22/xVariable); 
      val23 = analogRead(channelAI);       
      val23 = (val23/xVariable);          
      val24 = analogRead(channelAI);      
      val24 = (val24/xVariable);   
      val25 = analogRead(channelAI);       
      val25 = (val25/xVariable);          
      val26 = analogRead(channelAI);      
      val26 = (val26/xVariable); 
      val27 = analogRead(channelAI);       
      val27 = (val27/xVariable);          
      val28 = analogRead(channelAI);      
      val28 = (val28/xVariable); 
      val29 = analogRead(channelAI);       
      val29 = (val29/xVariable);          
      val30 = analogRead(channelAI);      
      val30 = (val30/xVariable); 
      val31 = analogRead(channelAI);       
      val31 = (val31/xVariable);          
      val32 = analogRead(channelAI);      
      val32 = (val32/xVariable); 
      val33 = analogRead(channelAI);       
      val33 = (val33/xVariable);          
      val34 = analogRead(channelAI);      
      val34 = (val34/xVariable);   
      val35 = analogRead(channelAI);       
      val35 = (val35/xVariable);          
      val36 = analogRead(channelAI);      
      val36 = (val36/xVariable); 
      val37 = analogRead(channelAI);       
      val37 = (val37/xVariable);          
      val38 = analogRead(channelAI);      
      val38 = (val38/xVariable); 
      val39 = analogRead(channelAI);       
      val39 = (val39/xVariable);          
      val40 = analogRead(channelAI);      
      val40 = (val30/xVariable);  
      val41 = analogRead(channelAI);       
      val41 = (val41/xVariable);          
      val42 = analogRead(channelAI);      
      val42 = (val42/xVariable); 
      val43 = analogRead(channelAI);       
      val43 = (val43/xVariable);          
      val44 = analogRead(channelAI);      
      val44 = (val44/xVariable);   
      val45 = analogRead(channelAI);       
      val45 = (val45/xVariable);          
      val46 = analogRead(channelAI);      
      val46 = (val46/xVariable); 
      val47 = analogRead(channelAI);       
      val47 = (val47/xVariable);          
      val48 = analogRead(channelAI);      
      val48 = (val48/xVariable); 
      val49 = analogRead(channelAI);       
      val49 = (val49/xVariable);          
      val50 = analogRead(channelAI);      
      val50 = (val40/xVariable);  
      val51 = analogRead(channelAI);       
      val51 = (val51/xVariable);          
      val52 = analogRead(channelAI);      
      val52 = (val52/xVariable); 
      val53 = analogRead(channelAI);       
      val53 = (val53/xVariable);          
      val54 = analogRead(channelAI);      
      val54 = (val54/xVariable);   
      val55 = analogRead(channelAI);       
      val55 = (val55/xVariable);          
      val56 = analogRead(channelAI);      
      val56 = (val56/xVariable); 
      val57 = analogRead(channelAI);       
      val57 = (val57/xVariable);          
      val58 = analogRead(channelAI);      
      val58 = (val58/xVariable); 
      val59 = analogRead(channelAI);       
      val59 = (val59/xVariable);          
      val60 = analogRead(channelAI);      
      val60 = (val50/xVariable);  
      val61 = analogRead(channelAI);       
      val61 = (val61/xVariable);          
      val62 = analogRead(channelAI);      
      val62 = (val62/xVariable); 
      val63 = analogRead(channelAI);       
      val63 = (val63/xVariable);          
      val64 = analogRead(channelAI);      
      val64 = (val64/xVariable);   
      val65 = analogRead(channelAI);       
      val65 = (val65/xVariable);          
      val66 = analogRead(channelAI);      
      val66 = (val66/xVariable); 
      val67 = analogRead(channelAI);       
      val67 = (val67/xVariable);          
      val68 = analogRead(channelAI);      
      val68 = (val68/xVariable); 
      val69 = analogRead(channelAI);       
      val69 = (val69/xVariable);          
      val70 = analogRead(channelAI);      
      val70 = (val60/xVariable);  
      val71 = analogRead(channelAI);       
      val71 = (val71/xVariable);          
      val72 = analogRead(channelAI);      
      val72 = (val72/xVariable); 
      val73 = analogRead(channelAI);       
      val73 = (val73/xVariable);          
      val74 = analogRead(channelAI);      
      val74 = (val74/xVariable);   
      val75 = analogRead(channelAI);       
      val75 = (val75/xVariable);          
      val76 = analogRead(channelAI);      
      val76 = (val76/xVariable); 
      val77 = analogRead(channelAI);       
      val77 = (val77/xVariable);          
      val78 = analogRead(channelAI);      
      val78 = (val78/xVariable); 
      val79 = analogRead(channelAI);       
      val79 = (val79/xVariable);          
      val80 = analogRead(channelAI);      
      val80 = (val80/xVariable);  
      val81 = analogRead(channelAI);       
      val81 = (val81/xVariable);          
      val82 = analogRead(channelAI);      
      val82 = (val82/xVariable); 
      val83 = analogRead(channelAI);       
      val83 = (val83/xVariable);          
      val84 = analogRead(channelAI);      
      val84 = (val84/xVariable);   
      
  nokia.clear();                       // clear the LCD screen so we can draw new pixels
 
 
      nokia.setPixel(0, val1, BLACK); 
      nokia.setPixel(1, val2, BLACK); 
      nokia.setPixel(2, val3, BLACK); 
      nokia.setPixel(3, val4, BLACK);
      nokia.setPixel(4, val5, BLACK); 
      nokia.setPixel(5, val6, BLACK);
      nokia.setPixel(6, val7, BLACK); 
      nokia.setPixel(7, val8, BLACK);
      nokia.setPixel(8, val9, BLACK); 
      nokia.setPixel(9, val10, BLACK);
      nokia.setPixel(10, val11, BLACK); 
      nokia.setPixel(11, val12, BLACK); 
      nokia.setPixel(12, val13, BLACK); 
      nokia.setPixel(13, val14, BLACK);
      nokia.setPixel(14, val15, BLACK); 
      nokia.setPixel(15, val16, BLACK);
      nokia.setPixel(16, val17, BLACK); 
      nokia.setPixel(17, val18, BLACK);
      nokia.setPixel(18, val19, BLACK); 
      nokia.setPixel(19, val20, BLACK);
      nokia.setPixel(20, val21, BLACK); 
      nokia.setPixel(21, val22, BLACK); 
      nokia.setPixel(22, val23, BLACK); 
      nokia.setPixel(23, val24, BLACK);
      nokia.setPixel(24, val25, BLACK); 
      nokia.setPixel(25, val26, BLACK);
      nokia.setPixel(26, val27, BLACK); 
      nokia.setPixel(27, val28, BLACK);
      nokia.setPixel(28, val29, BLACK); 
      nokia.setPixel(29, val30, BLACK);
      nokia.setPixel(30, val31, BLACK); 
      nokia.setPixel(31, val32, BLACK); 
      nokia.setPixel(32, val33, BLACK); 
      nokia.setPixel(33, val34, BLACK);
      nokia.setPixel(34, val35, BLACK); 
      nokia.setPixel(35, val36, BLACK);
      nokia.setPixel(36, val37, BLACK); 
      nokia.setPixel(37, val38, BLACK);
      nokia.setPixel(38, val39, BLACK); 
      nokia.setPixel(39, val40, BLACK);
      nokia.setPixel(40, val41, BLACK); 
      nokia.setPixel(41, val42, BLACK); 
      nokia.setPixel(42, val43, BLACK); 
      nokia.setPixel(43, val44, BLACK);
      nokia.setPixel(44, val45, BLACK); 
      nokia.setPixel(45, val46, BLACK);
      nokia.setPixel(46, val47, BLACK); 
      nokia.setPixel(47, val48, BLACK);
      nokia.setPixel(48, val49, BLACK); 
      nokia.setPixel(49, val50, BLACK);
      nokia.setPixel(50, val51, BLACK); 
      nokia.setPixel(51, val52, BLACK); 
      nokia.setPixel(52, val53, BLACK); 
      nokia.setPixel(53, val54, BLACK);
      nokia.setPixel(54, val55, BLACK); 
      nokia.setPixel(55, val56, BLACK);
      nokia.setPixel(56, val57, BLACK); 
      nokia.setPixel(57, val58, BLACK);
      nokia.setPixel(58, val59, BLACK); 
      nokia.setPixel(59, val60, BLACK);
      nokia.setPixel(50, val61, BLACK); 
      nokia.setPixel(61, val62, BLACK); 
      nokia.setPixel(62, val63, BLACK); 
      nokia.setPixel(63, val64, BLACK);
      nokia.setPixel(64, val65, BLACK); 
      nokia.setPixel(65, val66, BLACK);
      nokia.setPixel(66, val67, BLACK); 
      nokia.setPixel(67, val68, BLACK);
      nokia.setPixel(68, val69, BLACK); 
      nokia.setPixel(69, val70, BLACK);
      nokia.setPixel(70, val71, BLACK); 
      nokia.setPixel(71, val72, BLACK); 
      nokia.setPixel(72, val73, BLACK); 
      nokia.setPixel(73, val74, BLACK);
      nokia.setPixel(74, val75, BLACK); 
      nokia.setPixel(75, val76, BLACK);
      nokia.setPixel(76, val77, BLACK); 
      nokia.setPixel(77, val78, BLACK);
      nokia.setPixel(78, val79, BLACK); 
      nokia.setPixel(79, val80, BLACK);
      nokia.setPixel(80, val81, BLACK); 
      nokia.setPixel(81, val82, BLACK); 
      nokia.setPixel(82, val83, BLACK); 
      nokia.setPixel(83, val84, BLACK);
 
  
  nokia.display();                     // show the changes to the buffer
 
} 



